#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2013/09/22 15:08:11 +0900>
#
# Tmxt@CǂݍDXRubyŕ`悷Tv

require 'dxruby'
require 'tmx'

# BG}bvf[^(񎟌z)擾
def get_map_data(tmx, layer_name)
  mapw = tmx.width
  maph = tmx.height
  mapdata = []
  i = 0
  tmx.layers.each do |layer|
    next if layer.name != layer_name
    maph.times do |my|
      lines = []
      mapw.times do |mx|
        n = layer.data[i]
        lines.push((n <= 0)? 0 : n - 1)
        i += 1
      end
      mapdata.push(lines)
    end
    return mapdata
  end
end

tmx = Tmx.load("mylevel1.tmx") # tmxt@Cǂݍ݁E

# }bvp摜(32x32,256x768)ƃIuWFNgp摜(24x24,192x96)ǂݍ
imgarr = Image.loadTiles("mylevel1_tiles.png", 256/32, 768/32)
objimgs = Image.loadTiles("item_mix_all.png", 192/24, 96/24)

# BG}bvf[^(񎟌z)擾
layers = []
layers.push(get_map_data(tmx, "layer4"))
layers.push(get_map_data(tmx, "layer3"))
layers.push(get_map_data(tmx, "layer2"))
# layers.push(get_map_data(tmx, "layer1")) # A^p

# BG}bṽXN[ől擾
bgxmax = tmx.tilewidth * tmx.width - 640
bgymax = tmx.tileheight * tmx.height - 480

# ʏc^C擾
bgtw = 640 / tmx.tilewidth
bgth = 480 / tmx.tileheight

# IuWFNgC[擾
sprs = []
tmx.object_groups[0].objects.each do |obj|
  x = obj.x + 16 - 12 # zu^C̍WBWł͂ȂB
  y = obj.y - 16 - 12
  case obj.name
  when "ruby"
    sprs.push(Sprite.new(x, y, objimgs[6]))
  when "banana"
    sprs.push(Sprite.new(x, y, objimgs[8]))
  when "playerborn"
    sprs.push(Sprite.new(x, y, objimgs[16]))
  when "door"
    sprs.push(Sprite.new(x, y, objimgs[24]))
  end
end

bx, by = 0, 0
font = Font.new(26)
framecount = 0

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE)
  
  # L[͂ŃXN[
  old_bx = bx
  old_by = by
  spd = 8
  bx -= spd if Input.keyDown?(K_LEFT)
  bx += spd if Input.keyDown?(K_RIGHT)
  by -= spd if Input.keyDown?(K_UP)
  by += spd if Input.keyDown?(K_DOWN)
  bx = 0 if bx < 0
  by = 0 if by < 0
  bx = bgxmax if bx > bgxmax
  by = bgymax if by > bgymax

  # XN[ړʂL^Ă
  bx_diff = bx - old_bx
  by_diff = by - old_by

  # BG}bv`
  bgspd = [0.25, 0.5, 1.0, 1.0] # eBGC[̃XN[x
  layers.each_with_index do |dt, i|
    bgx = bx * bgspd[i]
    bgy = by * bgspd[i]
    Window.drawTile(0, 0, dt, imgarr, bgx, bgy, bgtw, bgth)
  end

  # IuWFNgWXN[ړʂŕύX
  sprs.each do |spr|
    spr.x -= bx_diff
    spr.y -= by_diff
  end
  
  # IuWFNg`
  Sprite.draw(sprs) if (framecount & 0x04 == 0)
  
  # bZ[W`
  Window.drawFont(4, 4, "ŃXN[", font)

  framecount += 1
end

